// This may look like C code, but it is really -*- C++ -*-

//   Module      : Address.h   Version 1.8
//   LastSCCS    : 7/29/91  18:00:05
//   LastEdit    : "Thu Mar  7 11:20:52 1991"
//   Description : 
//   Author      : 
//   Copyright   : GMD Schloss Birlinghoven

#ifndef Address_H
#define Address_H

#include "Object.h"
#include "String.h"
#include "Date.h"
#include "Integer.h"

class Address: public VIRTUAL Object {
    DECLARE_MEMBERS(Address);

  public:
    Address(const String*, const String*, const String*, const String*,
	    const String*, const String*, const String*, const String*,
	    const String*, const String*, const Date*, const Date*,
	    const Integer* key_number, bool copy_members = YES );
    
    ~Address();
    
    String  *LastName() const     { return the_last_name; };
    String  *FirstNames() const   { return the_first_names; };
    String  *Street() const       { return the_street; };
    String  *HouseNumber() const  { return the_house_number; };
    String  *CountryCode() const  { return the_country_code; };
    String  *CityCode() const     { return the_city_code; };
    String  *City() const         { return the_city; };
    String  *LocalArea() const    { return the_local_area; };
    String  *Telephone() const    { return the_telephone; };
    String  *Email() const        { return the_email; };
    Date    *CreationDate() const { return the_creation_date; };
    Date    *LastModified() const { return the_last_modified; };
    Integer *KeyNumber() const    { return the_key_number; };
  private:
    // New member variables
    String  *the_last_name;
    String  *the_first_names;
    String  *the_street;
    String  *the_house_number;
    String  *the_country_code;
    String  *the_city_code;
    String  *the_city;
    String  *the_local_area;
    String  *the_telephone;
    String  *the_email;
    Date    *the_creation_date;
    Date    *the_last_modified;
    Integer *the_key_number;
  protected:		// storer() functions for object I/O
	virtual void storer(OIOofd&) const;
	virtual void storer(OIOout&) const;
  public:
	bool operator==(const Address&) const;
	bool operator!=(const Address& a) const
		{ return !(*this==a); }
	virtual	int compare(const Object&) const;
	virtual void deepenShallowCopy();
	virtual unsigned hash() const;
	virtual bool isEqual(const Object&) const;
	virtual void printOn(ostream& strm =cout) const;
	virtual const Class* species() const;
};

#endif Address_H

